clc
clear
changeCobraSolver('glpk');
load 'Lactate Data';
gMA = GeneNames;
model = readCbModel('msb201165-s3');

model=addReaction(model,'NADH_pro',{'nadh[c]','nad[c]','h[c]'},[-1 1 1],false,0,999999);
model=addReaction(model,'NADPH_pro',{'nadph[c]','nadp[c]','h[c]'},[-1 1 1],false,0,999999);
model=addReaction(model,'FADH2_pro',{'fadh2[c]','fad[c]','h[c]'},[-1 1 2],false,0,999999);
model1=model;
U=10^20;
C=4;
objw=cell(1,8);
objx=cell(1,8);
objz=cell(1,8);
KeyGene={'CYTBO3_4pp'}
for t=1:8
    model=model1;
    vMA  = GeneExp(:,t);
    model=changeRxnBounds(model,'EX_glc(e)',0,'l');
    model = changeRxnBounds(model,'EX_lac-L(e)',-1000,'l');
    model = changeRxnBounds(model,'EX_lac-L(e)',1000,'u');
    model=changeRxnBounds(model,'EX_o2(e)',-1000,'l');
    model=changeRxnBounds(model,'EX_o2(e)',1000,'u');
   [Is,Js,Its,Itt,Ittt,caps,dems,dists,lbs,ubs,dists1,dists2,dists3,dists4,dists5,caps1,caps3,caps2] =MRI(C,model,gMA,vMA,U,KeyGene);
    t
    wgdx ('trdat3', Is, Js,Its,Itt,Ittt,caps, dems, dists,lbs,ubs, dists1,dists2,dists3,dists4,dists5,caps1,caps3,caps2);
    
    gams_output = 'std';
    gams('mipTRFBAw mip=cplex');
    
    % now get the outputs from the GDX file produced by the GAMS run
    
    rs = struct('name','modelStat','form','full');
    r = rgdx ('trsol2', rs);
    modelstat = r.val;
    
    rs.name = 'solveStat';
    r = rgdx ('trsol2', rs);
    solvestat = r.val;
    
    rs.name = 'z';
    rs.field = 'l';
    r = rgdx ('trsol2', rs);
    z = r.val;
    objz{t}=z;
    
    rs.name = 'x';
    r = rgdx ('trsol2', rs);
    x = r.val;
    objx{t}=x;
    
    rs.name = 'w';
    r = rgdx ('trsol2', rs);
    w = r.val;
    objw{t}=w;
end