function [modelNew,matchRev,nRxnsR,nMetsR,RegulatedGenes]=addConstraints(model,C,gMA,vMA);
% 12/27/2016 Oveis Jamialahmadi, some modification on the original code to
% reduce the cpu-time

[model,matchRev,rev2irrev,irrev2rev] = convertToIrreversible(model);
[nMetsR,nRxnsR] = size(model.S);
nn=1; RegulatedGenes = ({});
%==========================================================================
vMR_temp = (0); extS = model.S;
for o=1:length(model.genes)
     if any(strcmp(model.genes(o),gMA)) % Gene names with no version in form of string
        if sum(model.rxnGeneMat(:,o))>0
            rxnId = model.rxnGeneMat(:,o);
            extS(nMetsR+nn,find(rxnId))=1;
            FoundLoci = find(strcmp(gMA,model.genes{o}));
            model.rxns{nRxnsR+nn}=model.genes{o};
            vM = sum(vMA(FoundLoci));
            vM=vM/numel(FoundLoci);
            extS(nMetsR+nn,nRxnsR+nn)=1;
            vMR_temp(nn)=vM;
            RegulatedGenes{nn} = model.genes{o};
            nn=nn+1;
        end
    end
end
%==========================================================================
model.b(nMetsR+1:nMetsR+numel(vMR_temp),1)= vMR_temp.*C;     
model.S = sparse(extS);
model.c(nRxnsR+1:nRxnsR+numel(vMR_temp))=0;
model.lb(nRxnsR+1:nRxnsR+numel(vMR_temp))=0;model.ub(nRxnsR+1:nRxnsR+numel(vMR_temp))=1e6;
model.rev(nRxnsR+1:nRxnsR+numel(vMR_temp))=0;

modelNew=model;

